#include "Mac Vars.h"
#include "Blitter.h"
#include <Displays.h>

#undef EXTERN
#define EXTERN extern
#if USEDISPLAYSPROCKET
#include "Use DrawSprockets.h"
#endif
#include "Mallocx.h"
#include "3deng.h"

#define SAVE(Y,X)   Y[X]=a, Y[X+1]=b, Y[X+2]=c, Y[X+3]=d;
#define LOAD(Y,X)	a=Y[X], b=Y[X+1], c=Y[X+2], d=Y[X+3];	

void ClearScreen()
{
int lines = 0;

	while(lines<gScreenRealHeight)
		{
		memset( gScreenAddr+(lines*gScreenRowBytes), 0, gScreenRealWidth);
		lines++;
		}
}

void BlitterInit(void)
{
GDHandle		mainScreen;
PixMapHandle	mainScreenPixMap;
DisplayIDType theID;
	
	DSpContext_GetDisplayID( theContext, &theID );
	DMGetGDeviceByDisplayID( theID, &mainScreen, false );

	Gdh = mainScreen;
	
	mainScreenPixMap = (**mainScreen).gdPMap;						// get screen pixMap
	LockPixels(mainScreenPixMap);
 	gScreenAddr = StripAddress(GetPixBaseAddr(mainScreenPixMap));	// make non-32bit friendly
	gScreenRowBytes = (long)(0x7FFF&(**mainScreenPixMap).rowBytes);	// calc screen's rowBytes
	gScreenRows = (long) (0x7FFF & ( **mainScreenPixMap).bounds.bottom);
	screenptr = (unsigned char *)MallocX(640*480);
#if USEDISPLAYSPROCKET
	gScreenRealWidth = myRealAttributes.displayWidth;
	gScreenRealHeight = myRealAttributes.displayHeight;
#else
	gScreenRealWidth = gScreenRowBytes;
	gScreenRealHeight = gScreenRows;
#endif
	BlitterMode = REAL_640480;
}

void BlitterEnd()
{
GDHandle		mainScreen;
PixMapHandle	mainScreenPixMap;

	mainScreen = GetMainDevice();									// get screen device
	mainScreenPixMap = (**mainScreen).gdPMap;						// get screen pixMap
	UnlockPixels(mainScreenPixMap);
	FreeX(screenptr);
}

asm void DoubleAcross(long *dest, unsigned char *src, short width, short addition, short height)
{
	lwz		r10, src
	lwz		r7, dest
	addi	r10, r10, -4
	addi	r7, r7, -4

	lhz		r6, height
@l0
	lhz		r0, addition
	add		r11, r7, r0
	add		r11, r11, r0
	add		r12, r11, r0
	mr		r7, r11
	
	mr		r14, r10
	lhz		r0, width
	mtctr	r0
@l1
	lwzu	r5, 4(r10)

	mr		r13, r5
	rlwimi	r13, r5, 24, 8, 23
	rlwimi	r13, r5, 16, 24, 31
	stwu	r13, 4(r11)
	stwu	r13, 4(r12)

	mr	r13, r5
	rlwimi	r13, r5, 16, 0, 15
	rlwimi	r13, r13, 8, 8, 23
	stwu	r13, 4(r11)
	stwu	r13, 4(r12)

	lwzu	r5, 4(r10)

	mr		r13, r5
	rlwimi	r13, r5, 24, 8, 23
	rlwimi	r13, r5, 16, 24, 31
	stwu	r13, 4(r11)
	stwu	r13, 4(r12)

	mr	r13, r5
	rlwimi	r13, r5, 16, 0, 15
	rlwimi	r13, r13, 8, 8, 23
	stwu	r13, 4(r11)
	stwu	r13, 4(r12)

	bdnz	@l1
	
	addi	r10, r14, 320
	addi	r6, r6, -1
	cmpi	cr0, 0, r6, 0
	bne+	@l0
	
	blr
}

void BlitBufferToScreen(double *srcPtr)
{
	switch(BlitterMode)
		{
		case DOUBLE_320200:
	  			BlitDouble320(srcPtr, 200);
	  			break;
		case DOUBLE_320240:
	  			BlitDouble320(srcPtr, 240);
	  			break;
		case REAL_640400:
	  			BlitReal640(srcPtr, 400);
	  			break;
		case REAL_640480:
	  			BlitReal640(srcPtr, 480);
				break;
		}
}

//#define		Scr100		0
//#define		Scr85		1
//#define		Scr85w		2
//#define		Scr75		3
//#define		Scr75w		4
//#define		Scr65		5
//#define		Scr65w		6
//#define		Scr50		7
//#define		Scr50w		8
//#define		Scr40w		9

//extern setup_info setup;
//static float Widths[] ={1.0, .85, .90, .75, .80, .65, .70, .50, .55};
//static float Heights[]={1.0, .85, .85, .75, .75, .65, .65, .50, .50};

void BlitDouble320(double *srcPtr, short height)
{
long    width = 320/sizeof(double);
BYTE	*destPtr;
//short	height2 = height;
  
//	height *= Heights[setup.screen_size];
 	destPtr = (BYTE *)gScreenAddr + ((((gScreenRealHeight - height - height)/2)-2) * gScreenRowBytes) + ((gScreenRealWidth - 640)/2);
//	destPtr += ((height2-height)/2)*gScreenRowBytes;
	DoubleAcross((long *)destPtr, (unsigned char *)srcPtr, width, gScreenRealWidth, height);
}

void BlitReal640(double *srcPtr, short y1)
{
register char	*destPtr = (char *)gScreenAddr;			// get ptr to start of scan line
register long	rowBytes = gScreenRowBytes;
double *q;
double a,b,c,d;

	destPtr += (((gScreenRealHeight - y1)/2 ) * rowBytes) + ((gScreenRealWidth - 640)/2);
	while(y1--)
	  {
	  q = (double *)destPtr;
	  LOAD(srcPtr,0); SAVE(q,0);
	  LOAD(srcPtr,4); SAVE(q,4);
	  LOAD(srcPtr,8); SAVE(q,8);
	  LOAD(srcPtr,12); SAVE(q,12);
	  LOAD(srcPtr,16); SAVE(q,16);
	  LOAD(srcPtr,20); SAVE(q,20);
	  LOAD(srcPtr,24); SAVE(q,24);
	  LOAD(srcPtr,28); SAVE(q,28);
	  LOAD(srcPtr,32); SAVE(q,32);
	  LOAD(srcPtr,36); SAVE(q,36);
	  LOAD(srcPtr,40); SAVE(q,40);
	  LOAD(srcPtr,44); SAVE(q,44);
	  LOAD(srcPtr,48); SAVE(q,48);
	  LOAD(srcPtr,52); SAVE(q,52);
	  LOAD(srcPtr,56); SAVE(q,56);
	  LOAD(srcPtr,60); SAVE(q,60);
	  LOAD(srcPtr,64); SAVE(q,64);
	  LOAD(srcPtr,68); SAVE(q,68);
	  LOAD(srcPtr,72); SAVE(q,72);
	  LOAD(srcPtr,76); SAVE(q,76);
	  destPtr += gScreenRowBytes;
	  srcPtr+=(640/8);
	  }
}

void BlockCopy(char *srcPtr, short x, short y, short x1, short y1, short f)
{
register char	*destPtr;

	destPtr =  (char *)gScreenAddr + (((gScreenRealHeight - 480)/2 ) * gScreenRowBytes) + ((gScreenRealWidth - 640)/2);
	destPtr += (y * gScreenRowBytes) + x;

	if(y+y1>479)
	  y1 -= ((y+y1)-479);

	if(y>0)
		while(y1--)
	  		{
	  		memcpy(destPtr, srcPtr, x1);
	  		destPtr += gScreenRowBytes;
	  		srcPtr += f;
	  		}
}
