#include "Mac Vars.h"
#include "Init.h"

#undef EXTERN
#define EXTERN extern
#include "Apple Menu.h"
#include "Failure.h"

static	void	StandardInitialization(short callsToMoreMasters);
static	void	InitToolBox(void);
static	void	StandardMenuSetup(short MBARID, short AppleMenuID);
static	void	PullApplicationToFront(void);


/*****************************************************************************/




static	void	InitToolBox(void)
{
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	InitCursor();
}



/*****************************************************************************/



static	void	StandardInitialization(short callsToMoreMasters)
{
	InitToolBox();

	while (callsToMoreMasters--) MoreMasters();

	PullApplicationToFront();
}



/*****************************************************************************/




static	void	PullApplicationToFront(void)
{
#define kBroughtToFront 3

	EventRecord event;
	short		count;

	for (count = 1; count <= kBroughtToFront; count++)
		EventAvail(everyEvent, &event);
}



/*****************************************************************************/




void	Initialize(short moreMasters, long minimumSize)
{
long	total,contig;

	StandardInitialization(moreMasters);
		
	/* We used to make a check for memory at this point by examining
	** ApplLimit, ApplicZone, and StackSpace and comparing that to the minimum
	** size we told the Finder we needed.  This did not work well because it
	** assumed too much about the relationship between what we asked
	** the Finder for and what we would actually get back, as well as how to
	** measure it.  Instead, we will use an alternate method comprised of
	** two steps. */

	/* It is better to first check the size of the application heap against a
	** value that you have determined is the smallest heap the application can
	** reasonably work in.  This number should be derived by examining the
	** size of the heap that is actually provided by the Finder when the
	** minimum size requested is used.  The derivation of the minimum size
	** requested from MultiFinder is described in DTS.Lib.h.  The check should
	** be made because the preferred size can end up being set smaller than
	** the minimum size by the user.  This extra check acts to ensure that
	** your application is starting from a solid memory foundation. */

//	if ((long)GetApplLimit() - (long)ApplicZone() < minimumSize)
//		Fail(MemError(), __FILE__, __LINE__, TRUE, "\pThis Game Needs A Minimum of 4000K to Run");

	/* Next, make sure that enough memory is free for your application to run.
	** It is possible for a situation to arise where the heap may have been of
	** required size, but a large scrap was loaded which left too little
	** memory.  To check for this, call PurgeSpace and compare the result with
	** a value that you have determined is the minimum amount of free memory
	** your application needs at initialization.  This number can be derived
	** several different ways.  One way that is fairly straightforward is to
	** run the application in the minimum size configuration as described
	** previously.  Call PurgeSpace at initialization and examine the value
	** returned.  However, you should make sure that this result is not being
	** modified by the scraps presence.  You can do that by calling ZeroScrap
	** before calling PurgeSpace.  Make sure to remove that call before
	** shipping, though. */

	PurgeSpace(&total, &contig);
//	if (total < minimumSize)
//		Fail(MemError(), __FILE__, __LINE__, TRUE, "\pThis Game Needs A Minimum of 4000K to Run");
	AvailableMemory = total/1024;
	StandardMenuSetup(rMenuBar, mApple);

	qd.randSeed = TickCount();
}



/*****************************************************************************/




void	StandardMenuSetup(short MBARID, short AppleMenuID)
{
	Handle 		menuBar = GetNewMBar(MBARID);			/* Read menus into menu bar. */
	MenuHandle	menu = GetMHandle(mFile);
	
	
	if (!menuBar)
		Fail(ResError(), __FILE__, __LINE__, TRUE, "\pCould Not Create Menu Bar");

	SetMenuBar(menuBar);							/* Install menus. */
	DisposHandle(menuBar);
	AddResMenu(GetMHandle(AppleMenuID), 'DRVR');	/* Add DA names to Apple menu. */
	
//	SetItemMark(menu, kShowFPS, (gShowFPS) ? checkMark : noMark);
		
	DrawMenuBar();
}


