//	------------------------------------------------------------------------------------------	
//
//		Copyright 1995, 1996, Interplay Productions, Inc.
//		Not to be distributed without express consent of Interplay Productions
//		You can use this code in MacPlay games, but nowhere else.
//
//		Written by Chris De Salvo
//
//	------------------------------------------------------------------------------------------	

#ifndef __CDUTILS__
#define __CDUTILS__

//	------------------------------	Includes
//	------------------------------	Public Definitions

//	Audio playback modes

#define playmodeMute			0x00
#define playmodeRightOnly		0x05
#define playmodeStereo			0x09
#define playmodeLeftOnly			0x0A
#define playmodeMono			0x0F

//	Values that can be returned when you ask
//	for the speed of the spindle

#define kSingleSpeed				0x00
#define kDoubleSpeed			0xFF

//	------------------------------	Public Types

typedef enum
{
	isOnCDFalse,
	isOnCDTrue,
	isOnCDErr
} IsOnCDResult;

//	------------------------------	Public Variables
//	------------------------------	Public Functions

#ifdef __cplusplus
extern "C" {
#endif

extern OSErr CDOpen(void);
extern short CDGetSpeed(void);
extern OSErr CDPlayAudioTrack(char trackNumber, char playMode);
extern OSErr CDStopAudioPlayback(void);
extern OSErr CDGetCurrentAudioTrack(short *theTrack);
extern IsOnCDResult CDIsFileOnCD(short fileRef);
extern Boolean CDIsCDInserted(void);
extern short CDGetNumTracks(void);

#ifdef __cplusplus
}
#endif

#endif