#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <sioux.h>

typedef struct Z0000 {
	       char *Name;
	       long Value;
	       struct Z0000 *Next;
	       } Labels;

// Defines
void main(void);
void KillList(Labels *start);
void GetWord(void);
void SkipWhiteSpaces(void);
long Evaluate(void);
long Evaluate1(void);

// Variables
char Word[128];
char Name[128];
char Liine[256];
char *Linep;

Labels *ListStart;
Labels *ListStart;
Labels *Here;

void main()
{
FILE *fp,*fp1;
int  mode=1;
char *linen, *linev;
long value;

	SIOUXSettings.autocloseonquit = true;
	SIOUXSettings.asktosaveonclose = false;

	fp  = fopen("Defines.h","r");
	fp1 = fopen("Sprite Defines.h","w+");

	printf("Processing DEFINES.H\n");

	ListStart = (struct Z0000 *)calloc(1, sizeof(Labels));
    Here = ListStart;

	while(fgets(Liine, sizeof(Liine), fp))
		{
		if(Liine[0]=='\r')
			strcpy( Liine, Liine+1);
	  	switch(mode)
	    	{
	    	case(0):	fprintf(fp1, "%s", Liine);
						break;
	    	case(1):	if(!memcmp(Liine, "#define", 7))
			  				{
			  				Linep = Liine+7;
			  				SkipWhiteSpaces(); linen = Linep;
							GetWord(); strcpy(Name,Word);
							SkipWhiteSpaces(); linev = Linep;
							value = Evaluate();
							Here->Name  = (char *)malloc(strlen(Name)+1); strcpy(Here->Name,Name);
							Here->Value = value;
							Here->Next  = (struct Z0000 *)calloc(1,sizeof(Labels));
							Here = Here -> Next;
							if(strlen(Name)<8)
								fprintf(fp1, "#define\t%s\t\t\t%ld\t//%s", Name, value, linev);
							else if(strlen(Name)<16)
								fprintf(fp1, "#define\t%s\t\t%ld\t//%s", Name, value, linev);
							else
								fprintf(fp1, "#define\t%s\t%ld\t//%s", Name, value, linev);
							}
						else
							fprintf(fp1, "%s", Liine);
						break;
	 		}
		}
	KillList(ListStart);
	fclose(fp1);
	fclose(fp);
}

void GetWord()
{
int i=0;

	while(!(*Linep==' ' || *Linep=='\t'))
	  Word[i++]=*Linep++;
	Word[i]=0;
}

void SkipWhiteSpaces()
{
	while(*Linep==' ' || *Linep=='\t')
	  Linep++;
}

void KillList(Labels *start)
{
Labels *s;

	do
	  {
	  if(start->Name) free(start->Name);
	  s = start->Next;
	  free(start);
	  start = s;
	  } while(start);
	ListStart = NULL;
}

long Evaluate()
{
long value;
int  quit=1;

	value = Evaluate1();
	while(quit)
	  {
	  switch(*Linep)
	    {
	    case(0x09):
			Linep++;
			break;
	    case(0x0a):
	    case(0x0d):
	    case(')'):
			quit = 0;
			break;
	    case('+'):  Linep++;
			value = value + Evaluate1();
			break;
	    case('*'):  Linep++;
			value = value * Evaluate1();
			break;
	    default:
			printf("Line here:%s",Linep);
			quit = 0;
			break;
	    }
	  }
	return value;
}

long Evaluate1()
{
long value;
int  i;
Labels *s=ListStart;

	SkipWhiteSpaces();
	if(isdigit(*Linep))
	  {
	  if(*(Linep+1)=='x')
	    {
	    Linep+=2;
	    value = 0;
	    while(isxdigit(*Linep))
	      {
	      value *= 16;
	      if(isdigit(*Linep))
		value += (*Linep++-48);
	      else if(*Linep>'Z')
		value += 10 + (*Linep++-'a');
	      else
		value += 10 + (*Linep++-'A');
	      }
	    }
	  else
	    {
	    value = 0;
	    while(isdigit(*Linep))
	      value = (value*10) + (*Linep++-48);
	    }
	  }
	else if(isalpha(*Linep))
	  {
	  i=0;
	  while(isalnum(*Linep) || *Linep=='_')
	    Word[i++]=*Linep++;
	  Word[i]=0;
	  while(s)
	    {
	    if(!strcmp(s->Name,Word))
	      return s->Value;
	    s=s->Next;
	    }
	  printf("Could Not Find %s\n", Word);
          return 0;
	  }
	else if(*Linep=='(')
	  {
	  Linep++;
	  value = Evaluate();
	  if(*Linep==')')
	    Linep++;
	  else
	    putchar(7);
	  }
	else
	  putchar(7);

	SkipWhiteSpaces();
	return value;
}
