#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sioux.h>
#include <ctype.h>

#define RESNAME		"\pActua Soccer Res1"
#define RESNAME2	"\pActua Soccer Res2"
#define MYDATA		'ACTU'

//____________________________________________________________
#define	NULL		0
#define	LF			10
#define CR			13
#define INVERTWORD	1
#define INVERTLONG	2

//____________________________________________________________
void InitializeToolbox( void );
void InitializeToolbox( void );
void Process(char *filename, char *offfname, long mydata);
void Process2(char *filename, long mydata, int resnum);
void ProcessConvert(char *filename, char *offsetname, long mydata);
void ProcessText( char *text[], const unsigned char *Name, int resnum);
void SaveFromFileToResource( long theResID, long offset, long size, long Mydata);
void InvertLong( unsigned char *addr, int howmany);
void InvertShort( unsigned char *addr, int howmany);
signed int ReadLine(FILE *fp,char *buf);
int TestLine( char *theline, int theRedID);

extern char *lang1[];
extern char *lang2[];
extern char *lang3[];
extern char *lang4[];
extern char *lang5[];
extern char *lang6[];
extern char *EnglishText[];
extern char *FrenchText[];
extern char *GermanText[];
extern char *NorwegianText[];
extern char *formation_types[];
extern char *sky_types1[];
extern char *sky_types2[];
extern char *sky_types3[];
extern char *sky_types4[];
extern char *sky_types5[];
extern char *sky_types6[];
extern char *sub_types1[];
extern char *sub_types2[];
extern char *sub_types3[];
extern char *sub_types4[];
extern char *sub_types5[];
extern char *sub_types6[];
extern char *sta_types1[];
extern char *sta_types2[];
extern char *sta_types3[];
extern char *sta_types4[];
extern char *sta_types5[];
extern char *sta_types6[];
extern char *pit_types1[];
extern char *pit_types2[];
extern char *pit_types3[];
extern char *pit_types4[];
extern char *pit_types5[];
extern char *pit_types6[];
extern char *wnd_types1[];
extern char *wnd_types2[];
extern char *wnd_types3[];
extern char *wnd_types4[];
extern char *wnd_types5[];
extern char *wnd_types6[];
extern char *size_types[];
extern char *time_types[];
extern char *cam_types1[];
extern char *cam_types2[];
extern char *cam_types3[];
extern char *cam_types4[];
extern char *cam_types5[];
extern char *cam_types6[];
extern char *ply_labels1[];
extern char *ply_labels2[];
extern char *ply_labels3[];
extern char *ply_labels4[];
extern char *ply_labels5[];
extern char *ply_labels6[];
extern char *aud_types1[];
extern char *aud_types2[];
extern char *aud_types3[];
extern char *aud_types4[];
extern char *aud_types5[];
extern char *aud_types6[];
extern char *No_players1[];
extern char *No_players2[];
extern char *No_players3[];
extern char *No_players4[];
extern char *No_players5[];
extern char *No_players6[];
extern char *Game_types1[];
extern char *Game_types2[];
extern char *Game_types3[];
extern char *Game_types4[];
extern char *Game_types5[];
extern char *Game_types6[];
extern char *comp_types1[];
extern char *comp_types2[];
extern char *comp_types3[];
extern char *comp_types4[];
extern char *comp_types5[];
extern char *comp_types6[];
extern char *NETW_types1[];
extern char *NETW_types2[];
extern char *NETW_types3[];
extern char *NETW_types4[];
extern char *NETW_types5[];
extern char *NETW_types6[];
extern char *slot_names1[];
extern char *slot_names2[];
extern char *slot_names3[];
extern char *slot_names4[];
extern char *slot_names5[];
extern char *slot_names6[];
extern char *ROUNDS1[];
extern char *ROUNDS2[];
extern char *ROUNDS3[];
extern char *ROUNDS4[];
extern char *ROUNDS5[];
extern char *ROUNDS6[];
extern char *VENUES1[];
extern char *VENUES2[];
extern char *VENUES3[];
extern char *VENUES4[];
extern char *VENUES5[];
extern char *VENUES6[];


//____________________________________________________________
short		gResFile;
long		newID = 128;
FILE 		*DataFile;
int			Language = 0;

typedef struct {
				long offset;
				long size;
				} DIR;

DIR	Directory[1024];

char *FapNames[]={":Fap:Fap.dat",
				 ":Fap:Fap.dat",
				 ":Fap:Fap.dat",
				 ":Fap:Fap.dat",
				 ":Fap:Fap.dat",
				 ":Fap:Fap.dat" };

char *FapNames2[]={":Fap:Fap.off",
				  ":Fap:Fap.off",
				  ":Fap:Fap.off",
				  ":Fap:Fap.off",
				  ":Fap:Fap.off",
				  ":Fap:Fap.off" };

char *DataNames[]={":Frontend:English.Dat",
				  ":Frontend:French.Dat",
				  ":Frontend:German.Dat",
				  ":Frontend:English.Dat",
				  ":Frontend:French.Dat",
				  ":Frontend:Norway.Dat" };

char *DataNames2[]={":Frontend:English.Off",
				   ":Frontend:French.Off",
				   ":Frontend:German.Off",
				   ":Frontend:English.Off",
				   ":Frontend:French.Off",
				   ":Frontend:Norway.Off" };

char *GameNames[]={":Game:English.Dat",
				   ":Game:French.Dat",
				   ":Game:German.Dat",
				   ":Game:English.Dat",
				   ":Game:French.Dat",
				   ":Game:Norway.Dat" };

char *GameNames2[]={":Game:English.Off",
				   ":Game:French.Off",
				   ":Game:German.Off",
				   ":Game:English.Off",
				   ":Game:French.Off",
				   ":Game:Norway.Off" };
				   
char theLine[128];

void  main( void )
{
StandardFileReply reply;
OSErr       theError;
long		theResID;
short		oldFile;
short		resnum;
	
	InitializeToolbox();
	
	MaxApplZone();
	
	SIOUXSettings.autocloseonquit = true;
	SIOUXSettings.asktosaveonclose = false;
	
	Language = 0;
	
//	while(Language < 2)
		{
		
		StandardPutFile("\pCreate Which Resource", RESNAME, &reply);
   		
   		if(reply.sfGood == TRUE)
     		{
     		oldFile = CurResFile();
   
     		if(reply.sfReplacing == TRUE)
       			FSpDelete(&reply.sfFile);
     
     		FSpCreate(&reply.sfFile, 'RSED', MYDATA, 0);
     		FSpCreateResFile(&reply.sfFile, 'RSED', MYDATA, 0);
   
     		gResFile = FSpOpenResFile(&reply.sfFile, fsRdWrPerm);
     		UseResFile(gResFile);
  
 	 		Process( FapNames[Language], FapNames2[Language], 'FAP ');
 	 		Process( DataNames[Language], DataNames2[Language], 'DATA');

	 		Process2("TAC_316.TAC", 'TAC ', 128);
	 		Process2("TAC_406.TAC", 'TAC ', 129);
	 		Process2("TAC_415.TAC", 'TAC ', 130);
	 		Process2("TAC_424.TAC", 'TAC ', 131);
	 		Process2("TAC_433.TAC", 'TAC ', 132);
	 		Process2("TAC_442.TAC", 'TAC ', 133);
	 		Process2("TAC_514.TAC", 'TAC ', 134);
	 		Process2("TAC_523.TAC", 'TAC ', 135);
	 		Process2("TAC_532.TAC", 'TAC ', 136);
	 		Process2("TAC_631.TAC", 'TAC ', 137);
	 
	 		switch(Language)
	 			{
	 			case(0):	ProcessText( lang1, "\pEnglish",  10000);
//	 						break;
	 			case(1):	ProcessText( lang2, "\pFrench",   10001);
//	 						break;
	 			case(2):	ProcessText( lang3, "\pGerman",   10002);
//	 						break;
	 			case(3):	ProcessText( lang4, "\pAmerican",  10003);
//	 						break;
	 			case(4):	ProcessText( lang5, "\pCanadian",   10004);
//	 						break;
	 			case(5):	ProcessText( lang6, "\pNoweigan", 10005);
//							break;
				}
				
			UseResFile(oldFile);
     		CloseResFile(gResFile);

     		StandardPutFile("\pCreate Which Resource", RESNAME2, &reply);
   
   			if(reply.sfGood == TRUE)
   				{
       			oldFile = CurResFile();
   
       			if(reply.sfReplacing == TRUE)
         			FSpDelete(&reply.sfFile);
       			FSpCreate(&reply.sfFile, 'RSED', MYDATA, 0);
       			FSpCreateResFile(&reply.sfFile, 'RSED', MYDATA, 0);
   
       			gResFile = FSpOpenResFile(&reply.sfFile, fsRdWrPerm);
       			UseResFile(gResFile);
 	   
				ProcessConvert( GameNames[Language], GameNames2[Language], 'ACTR' );
					   
				resnum = 20000;
				
	   			switch(Language)
	   				{
	   				case(0):	ProcessText( EnglishText,		"\pEnglish", resnum++);
								ProcessText( formation_types,	"\pFormation", resnum++);
	   							ProcessText( sky_types1,		"\pSky", resnum++);
	   	   						ProcessText( sub_types1,		"\pSubs", resnum++);
	   	   						ProcessText( sta_types1,		"\pStadiums", resnum++);
	   	   						ProcessText( pit_types1,		"\pPitch", resnum++);
	   	   						ProcessText( wnd_types1,		"\pWind", resnum++);
	   	   						ProcessText( size_types,		"\pSize", resnum++);
	   	   						ProcessText( time_types,		"\pTime", resnum++);
	   	   						ProcessText( cam_types1,		"\pCamera", resnum++);
	   	   						ProcessText( ply_labels1,		"\pPlayers", resnum++);
	   	   						ProcessText( aud_types1,		"\pAudio", resnum++);
	   	   						ProcessText( No_players1,		"\pPlayers", resnum++);
	   	   						ProcessText( Game_types1,		"\pGame Types", resnum++);
	   	   						ProcessText( comp_types1,		"\pComp Types", resnum++);
	   	   						ProcessText( NETW_types1,		"\pNetwork Types", resnum++);
	   	   						ProcessText( slot_names1,		"\pSlot Names", resnum++);
	   	   						ProcessText( ROUNDS1,			"\pRound Types", resnum++);
	   	   						ProcessText( VENUES1,			"\pVenues", resnum++);
//								break;
	   				case(1):	ProcessText( FrenchText,		"\pFrench", resnum++);
								ProcessText( formation_types,	"\pFormation", resnum++);
	   							ProcessText( sky_types2,		"\pSky", resnum++);
	   	   						ProcessText( sub_types2,		"\pSubs", resnum++);
	   	   						ProcessText( sta_types2,		"\pStadiums", resnum++);
	   	   						ProcessText( pit_types2,		"\pPitch", resnum++);
	   	   						ProcessText( wnd_types2,		"\pWind", resnum++);
	   	   						ProcessText( size_types,		"\pSize", resnum++);
	   	   						ProcessText( time_types,		"\pTime", resnum++);
	   	   						ProcessText( cam_types2,		"\pCamera", resnum++);
	   	   						ProcessText( ply_labels2,		"\pPlayers", resnum++);
	   	   						ProcessText( aud_types2,		"\pAudio", resnum++);
	   	   						ProcessText( No_players2,		"\pPlayers", resnum++);
	   	   						ProcessText( Game_types2,		"\pGame Types", resnum++);
	   	   						ProcessText( comp_types2,		"\pComp Types", resnum++);
	   	   						ProcessText( NETW_types2,		"\pNetwork Types", resnum++);
	   	   						ProcessText( slot_names2,		"\pSlot Names", resnum++);
	   	   						ProcessText( ROUNDS2,			"\pRound Types", resnum++);
	   	   						ProcessText( VENUES2,			"\pVenues", resnum++);
//								break;
	   				case(2):	ProcessText( GermanText,		"\pGerman", resnum++);
								ProcessText( formation_types,	"\pFormation", resnum++);
	   							ProcessText( sky_types3,		"\pSky", resnum++);
	   	   						ProcessText( sub_types3,		"\pSubs", resnum++);
	   	   						ProcessText( sta_types3,		"\pStadiums", resnum++);
	   	   						ProcessText( pit_types3,		"\pPitch", resnum++);
	   	   						ProcessText( wnd_types3,		"\pWind", resnum++);
	   	   						ProcessText( size_types,		"\pSize", resnum++);
	   	   						ProcessText( time_types,		"\pTime", resnum++);
	   	   						ProcessText( cam_types3,		"\pCamera", resnum++);
	   	   						ProcessText( ply_labels3,		"\pPlayers", resnum++);
	   	   						ProcessText( aud_types3,		"\pAudio", resnum++);
	   	   						ProcessText( No_players3,		"\pPlayers", resnum++);
	   	   						ProcessText( Game_types3,		"\pGame Types", resnum++);
	   	   						ProcessText( comp_types3,		"\pComp Types", resnum++);
	   	   						ProcessText( NETW_types3,		"\pNetwork Types", resnum++);
	   	   						ProcessText( slot_names3,		"\pSlot Names", resnum++);
	   	   						ProcessText( ROUNDS3,			"\pRound Types", resnum++);
	   	   						ProcessText( VENUES3,			"\pVenues", resnum++);
//								break;
	   				case(3):	ProcessText( EnglishText,		"\pAmerican", resnum++);
								ProcessText( formation_types,	"\pFormation", resnum++);
	   							ProcessText( sky_types4,		"\pSky", resnum++);
	   	   						ProcessText( sub_types4,		"\pSubs", resnum++);
	   	   						ProcessText( sta_types4,		"\pStadiums", resnum++);
	   	   						ProcessText( pit_types4,		"\pPitch", resnum++);
	   	   						ProcessText( wnd_types4,		"\pWind", resnum++);
	   	   						ProcessText( size_types,		"\pSize", resnum++);
	   	   						ProcessText( time_types,		"\pTime", resnum++);
	   	   						ProcessText( cam_types4,		"\pCamera", resnum++);
	   	   						ProcessText( ply_labels4,		"\pPlayers", resnum++);
	   	   						ProcessText( aud_types4,		"\pAudio", resnum++);
	   	   						ProcessText( No_players4,		"\pPlayers", resnum++);
	   	   						ProcessText( Game_types4,		"\pGame Types", resnum++);
	   	   						ProcessText( comp_types4,		"\pComp Types", resnum++);
	   	   						ProcessText( NETW_types4,		"\pNetwork Types", resnum++);
	   	   						ProcessText( slot_names4,		"\pSlot Names", resnum++);
	   	   						ProcessText( ROUNDS4,			"\pRound Types", resnum++);
	   	   						ProcessText( VENUES4,			"\pVenues", resnum++);
//								break;
	   				case(4):	ProcessText( FrenchText,		"\pCanadian", resnum++);
								ProcessText( formation_types,	"\pFormation", resnum++);
	   							ProcessText( sky_types5,		"\pSky", resnum++);
	   	   						ProcessText( sub_types5,		"\pSubs", resnum++);
	   	   						ProcessText( sta_types5,		"\pStadiums", resnum++);
	   	   						ProcessText( pit_types5,		"\pPitch", resnum++);
	   	   						ProcessText( wnd_types5,		"\pWind", resnum++);
	   	   						ProcessText( size_types,		"\pSize", resnum++);
	   	   						ProcessText( time_types,		"\pTime", resnum++);
	   	   						ProcessText( cam_types5,		"\pCamera", resnum++);
	   	   						ProcessText( ply_labels5,		"\pPlayers", resnum++);
	   	   						ProcessText( aud_types5,		"\pAudio", resnum++);
	   	   						ProcessText( No_players5,		"\pPlayers", resnum++);
	   	   						ProcessText( Game_types5,		"\pGame Types", resnum++);
	   	   						ProcessText( comp_types5,		"\pComp Types", resnum++);
	   	   						ProcessText( NETW_types5,		"\pNetwork Types", resnum++);
	   	   						ProcessText( slot_names5,		"\pSlot Names", resnum++);
	   	   						ProcessText( ROUNDS5,			"\pRound Types", resnum++);
	   	   						ProcessText( VENUES5,			"\pVenues", resnum++);
//								break;
	   				case(5):	ProcessText( NorwegianText,		"\pNoweigan", resnum++);
								ProcessText( formation_types,	"\pFormation", resnum++);
	   							ProcessText( sky_types6,		"\pSky", resnum++);
	   	   						ProcessText( sub_types6,		"\pSubs", resnum++);
	   	   						ProcessText( sta_types6,		"\pStadiums", resnum++);
	   	   						ProcessText( pit_types6,		"\pPitch", resnum++);
	   	   						ProcessText( wnd_types6,		"\pWind", resnum++);
	   	   						ProcessText( size_types,		"\pSize", resnum++);
	   	   						ProcessText( time_types,		"\pTime", resnum++);
	   	   						ProcessText( cam_types6,		"\pCamera", resnum++);
	   	   						ProcessText( ply_labels6,		"\pPlayers", resnum++);
	   	   						ProcessText( aud_types6,		"\pAudio", resnum++);
	   	   						ProcessText( No_players6,		"\pPlayers", resnum++);
	   	   						ProcessText( Game_types6,		"\pGame Types", resnum++);
	   	   						ProcessText( comp_types6,		"\pComp Types", resnum++);
	   	   						ProcessText( NETW_types6,		"\pNetwork Types", resnum++);
	   	   						ProcessText( slot_names6,		"\pSlot Names", resnum++);
	   	   						ProcessText( ROUNDS6,			"\pRound Types", resnum++);
	   	   						ProcessText( VENUES6,			"\pVenues", resnum++);
								break;
					}
				UseResFile(oldFile);
       			CloseResFile(gResFile);
       			}
       		else
       			Language = 100;
     		}
     	else
     		Language = 100;
     	Language ++;
        }
}

void ProcessText( char *lang[], const unsigned char *Name, int resnum)
{
Handle theData;
int size=2, a;
char *p;

	for(a=0;lang[a];a++)
		size += strlen(lang[a])+1;
	
	theData = NewHandle(size); HLockHi(theData); p=*theData;
	*p++ = (a/256);
	*p++ = (a&255);
	
	for(a=0;lang[a];a++)
	  {
	  *p++ = strlen(lang[a]);
	  p = strcpy(p, lang[a]);
	  p += strlen(lang[a]);

	  }

	AddResource( (Handle)theData, 'STR#', resnum, Name);
	WriteResource( (Handle)theData);
	DetachResource( (Handle)theData);
	HUnlock(theData);
	ReleaseResource( theData );
	DisposeHandle(theData);
}

void Process2(char *filename,long mydata, int resnum)
{
FILE *fp=fopen(filename,"rb");
Handle theData;
int theSize, pos;
//unsigned char b0, b1, b2, b3, *p;

	printf("Processing %s\n",filename);
	theData = NewHandle(65536); HLockHi(theData);
	theSize=fread(*theData, 1, 65536, fp);
	fclose(fp);
	SetHandleSize(theData, theSize);

	InvertLong( (unsigned char *)*theData, theSize/4);

//	p = (unsigned char *)*theData;
//	for(pos=0; pos<theSize; pos+=4)
//	  {
//	  b0 = p[0]; b1 = p[1]; b2=p[2]; b3=p[3];
//	  p[0]=b3; p[1]=b2; p[2]=b1; p[3]=b0;
//	  p+=4;
//	  }
	
	AddResource( (Handle)theData, mydata, resnum, "\p");
	WriteResource( (Handle)theData);
	DetachResource( (Handle)theData);
	HUnlock(theData);
	ReleaseResource( theData );
	DisposeHandle(theData);
	fclose(fp);
}

void Process(char *filename,char *offfname,long mydata)
{
long		pos = 0, entries;
FILE *fp;

	printf("Processing %s\n",filename);
	fp = fopen(offfname,"rb");
	entries = fread(Directory,8,1024,fp);
	fclose(fp);

	InvertLong( (unsigned char *)&Directory, entries*2);

	DataFile = fopen(filename, "rb");
	pos = 0;	 
	newID=128;
	while(pos<entries)
		{
		printf("Directory %3d = %08lx %08lx\n",newID, Directory[pos].offset, Directory[pos].size);
		SaveFromFileToResource(newID++, Directory[pos].offset, Directory[pos].size, mydata);
		pos++;
		}
   	
     fclose(DataFile);
}

void SaveFromFileToResource( long theResID, long offset, long size, long Mydata)
{
OSErr	theError;
short	theResourceFileRef;
Handle	theData;

   theData = NewHandle(size);
   HLock(theData);

	if(fseek(DataFile, offset, 0))
	  printf("Failed To Seek\n");
	  
//	fread(ReadData, 1, size, DataFile);
	fread(*theData, 1, size, DataFile);
	
//   memcpy(*theData,ReadData,size);
        
//   theData = NewHandle(size);
//   HLock(theData);

   AddResource( (Handle)theData, Mydata, theResID, "\p");
   WriteResource( (Handle)theData);
   DetachResource( (Handle)theData);

   HUnlock(theData);
   ReleaseResource( theData );
   DisposeHandle(theData);
}

void ProcessConvert( char *data, char *off, long Mydata)
{
long	pos = 0, entries;
FILE	*fp, *fp1;
OSErr	theError;
short	theResourceFileRef;
Handle	theData;
int		theResID = 128, flag;

	printf("Processing %s\n", data);
	fp = fopen(off,"rb"); entries = fread(Directory,8,1024,fp); fclose(fp);
	InvertLong( (unsigned char *)&Directory, entries*2);

	fp = fopen( "::Game.equ", "r");
	fp1 = fopen( data, "rb");
	pos = 0; newID = 128;
	while(pos<entries)
		{
		printf("Directory %3d = %08lx %08lx\n",theResID, Directory[pos].offset, Directory[pos].size);
		do
		  {
		  ReadLine ( fp, theLine);
		  } while(!theLine[0]);

		if(fseek(fp1, Directory[pos].offset, 0))
			{
			printf("Failed To Seek\n");
			SysBeep(1);
			}
		else
			{
			theData = NewHandle(Directory[pos].size);
			if( theData)
				{
				HLock(theData);
				fread(*theData, 1, Directory[pos].size, fp1);
				flag = TestLine( theLine, theResID);
				if ( flag & INVERTWORD)
					InvertShort( (unsigned char *)*theData, Directory[pos].size/2);
				else if( flag & INVERTLONG)
					InvertLong( (unsigned char *)*theData, Directory[pos].size/4);
				AddResource( (Handle)theData, Mydata, theResID, "\p");
   				WriteResource( (Handle)theData);
   				DetachResource( (Handle)theData);
				ReleaseResource( theData );
   				DisposeHandle(theData);
				}
			else
				{
				printf("Memory Allocation Error\n");
				SysBeep(1);
				}
			}
		pos++;
		theResID++;
		}
	fclose( fp1);
	fclose( fp);
}

//____________________________________________________________
int TestLine( char *theline, int theResID)
{
Boolean getword = false;
char *p = theline;
char word[32];
int counter=0, chr, flag = 0;

	theResID = (theResID-128) * 8;

	while( *p)
	  {
	  if( getword)
	    {
	    if( isspace(*p))
	    	{
	    	switch(counter)
	    		{
	    		case(0):	if( strcmp(word, "#define"))
	    						{
	    						printf(" Illegal Line - '%s'\n", theline);
	    						SysBeep(1);
	    						}
	    					break;
	    		case(1):	if( !memcmp( word, "MPB_", 4))
								flag |= INVERTLONG;
							else if( !memcmp( word, "MP4_", 4))
								flag |= INVERTLONG;
							else if( !memcmp( word, "TMD_", 4))
								flag |= INVERTLONG;
//							else if( !memcmp( word, "PTS_", 4))
//								flag |= INVERTLONG;
//							else if( !memcmp( word, "FCE_", 4))
//								flag |= INVERTLONG;
	    					break;
	    		case(2):	if( atoi( word) != theResID)
	    						{
	    						printf(" Out Of Sync - '%s'\n", theline);
	    						SysBeep(1);
	    						}
	    					break;
	    		}
	    	getword = false;
	    	counter ++;
	    	}
	    else
	    	{
	    	word[chr] = *p++; word[++chr] = 0;
	    	}
	    }
	  else
	    {
	    if( isspace(*p))
	    	p++;
	    else
	    	{
	    	getword = true; chr=0;
	    	}
	    }
	  }	
	switch(counter)
		{
		case(2):	if( atoi( word) != theResID)
						{
						printf(" Out Of Sync - '%s'\n", theline);
						SysBeep(1);
						}
					break;
		default:	printf("Not Enough Parameters\n");
					SysBeep(1);
					break;
		}
	return flag;
}


//____________________________________________________________
void  InitializeToolbox( void )
{
   InitGraf( &qd.thePort );
   InitFonts();
   InitWindows();
   InitMenus();
   TEInit();
   InitDialogs( 0L );
   FlushEvents( everyEvent, 0 );
   InitCursor();
}

void InvertLong( unsigned char *addr, int howmany)
{
unsigned char b0;

	while( howmany--)
		{
		b0 = addr[0]; addr[0] = addr[3]; addr[3] = b0;
		b0 = addr[1]; addr[1] = addr[2]; addr[2] = b0;
		addr += 4;
		}
}

void InvertShort( unsigned char *addr, int howmany)
{
unsigned char b0;

	while( howmany--)
		{
		b0 = addr[0]; addr[0] = addr[1]; addr[1] = b0;
		addr += 2;
		}
}

signed int ReadLine(FILE *fp,char *buf)
	{
	  signed char c;
	  buf[0]=0;
	  int nc=0;

	  while((((c=fgetc(fp))!=LF)&&(c!=EOF)))
	  {
	    if (c==EOF || c==LF || c==255)
	      *(buf++)=0;
	    else
	    {
	      *(buf++)=c;
	      nc++;
	    }
	  }

	  if(c==LF)
	    {
	    c=fgetc(fp);
	    if(c==EOF)
	      ;
	    else if(c!=CR)
	      ungetc(c,fp);
	    }
	  if(c==EOF) nc=-1;
	    return(nc);
	}

