#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//#include <conio.h>

void	OpenNewACTRENDfile(void);
void	MotorolaConversion(void);
char	DoesDATfileExist(void);
void	ConvertDATfile(void);
char	ReadActrendOFFfile(void);
void	ConvertDataSegment(char *buf);
signed int ReadLine(FILE *fp,char *buf);
void    ProcessActrendEquFILE(void);
char   *strupr(char *string);

FILE 	*filein;
FILE	*fd;
FILE 	*fp2;
long seek_pos, file_size, len;
char	line[512];
int	Section;
char	SectionTypes[5000];
unsigned char buffer[1024000];
long 	length_count;

#define MAX_OFFSETS	2500

// DAT offset file format type
typedef struct {
	unsigned long offset;
	unsigned long size;
		}
	offset_defn;

offset_defn	Offset_table[MAX_OFFSETS];



#define	NULL       0
#define	LF        10
#define CR		  13

#define	NORMAL	   0
#define	MOTOROLA   1

//********************************************************************************************************************************

void	OpenNewACTRENDfile()
	{
	  FILE *fp2=fopen("MACREND.DAT","wb");
	}


//********************************************************************************************************************************

void	MotorolaConversion()
	{
	  unsigned char byte1,byte2,byte3,byte4;

	  for (long off=0;off<400000;off+=4)
	  {
	    byte1=buffer[off];
	    byte2=buffer[off+1];
	    byte3=buffer[off+2];
	    byte4=buffer[off+3];
	    buffer[off]=byte4;
	    buffer[off+1]=byte3;
	    buffer[off+2]=byte2;
	    buffer[off+3]=byte1;
	  }
	}

//********************************************************************************************************************************

char	DoesDATfileExist()
	{
	  FILE *fp3;
	  fp3=fopen("actrend.dat","rb");
	  if (!fp3)
	  {
	    printf("cannot find 'ACTREND.DAT' file...\n");
	    return(1);
	  }
	  else		
	  {
	    fclose(fp3);
	    return(0);
	  }
	}

//********************************************************************************************************************************

void	ConvertDATfile()
	{

	  for (int sect=0;sect<Section;sect++)
	  {
	    seek_pos=Offset_table[sect].offset;
	    file_size=Offset_table[sect].size;

	file_size=(file_size+3)&~3;

	    length_count+=file_size;

	    if (file_size>0)
	    {   
	      fd=fopen("ACTREND.DAT","rb");
	      fseek(fd,seek_pos,SEEK_SET);	
	      fread(buffer,sizeof(unsigned char),file_size,fd);
	      fclose(fd);

	      if (SectionTypes[sect]==MOTOROLA)
		MotorolaConversion();
		

	      printf("w  off = %#x	size = %#x\n",seek_pos,file_size);
	      fwrite(buffer,sizeof(unsigned char),file_size,fp2);
	    }

	    else
	      printf("   off = %#x	size = %#x\n",seek_pos,file_size);
	  }
	    printf("sections = %d	%d\n",Section,Section*8);
	}

//********************************************************************************************************************************

char	ReadActrendOFFfile()
	{
	  FILE *fp1;
	  char *p;
	  char c0,c1,c2,c3;
	  
	  fp1=fopen("actrend.off","rb");
	  if (!fp1)
	  {
	    printf("cannot find 'ACTREND.OFF' file...\n");
	    return(1);
	  }
	  else		
	  {
	    fread(Offset_table,sizeof(offset_defn),MAX_OFFSETS,fp1);
	    p = (char *)Offset_table;
	    for(int a=0; a<MAX_OFFSETS; a++)
	      {
	      c0 = p[0]; c1 = p[1]; c2 = p[2]; c3 = p[3];
	      p[0] = c3; p[1] = c2; p[2] = c1; p[3] = c0;
	      p+=4; 
	      c0 = p[0]; c1 = p[1]; c2 = p[2]; c3 = p[3];
	      p[0] = c3; p[1] = c2; p[2] = c1; p[3] = c0;
	      p+=4; 
	      }
	    fclose(fp1);
	    return(0);
	  }
	}

//********************************************************************************************************************************

void ConvertDataSegment(char *buf)
	{
	  char string[128];
	  char extension[4];
	  char x;
	  
	  for (x=0;x<7;x++)	    	 
	  {
	    string[x]=buf[x];
	  }
	  
	  string[x]=0;
	  strupr(string);			

	  if (!strcmp(string,"#DEFINE"))
	  {
	    char ex=0;	    	 
	    char x=8;
	    while (buf[x]!='_' && ex<4)
	    {
	      extension[ex]=buf[x];
              x++;ex++;
	    }

	    extension[ex]=0;
	    strupr(extension);			
	
	    if (!strcmp(extension,"MPB"))
	      SectionTypes[Section]=MOTOROLA;

	    else if (!strcmp(extension,"MP4"))
	      SectionTypes[Section]=MOTOROLA;

	    else if (!strcmp(extension,"TMD"))
	      SectionTypes[Section]=MOTOROLA;

	    else

	      SectionTypes[Section]=NORMAL;

	    Section++;

	  }
	}

//********************************************************************************************************************************

signed int ReadLine(FILE *fp,char *buf)
	{
	  signed char c;
	  buf[0]=0;
	  int nc=0;

	  while((((c=fgetc(fp))!=LF)&&(c!=EOF)))
	  {
	    if (c==EOF || c==LF || c==255)
	      *(buf++)=0;
	    else
	    {
	      *(buf++)=c;
	      nc++;
	    }
	  }

	  if(c==LF)
	    {
	    c=fgetc(fp);
	    if(c==EOF)
	      ;
	    else if(c!=CR)
	      ungetc(c,fp);
	    }
	  if(c==EOF) nc=-1;
	    return(nc);
	}

//********************************************************************************************************************************

void    ProcessActrendEquFILE()
	{
	  if (filein=fopen("actrend.equ","rt"),filein!=NULL)
	  {
	    while(ReadLine(filein,&line[0])>=0)
	    {
	      ConvertDataSegment(&line[0]);
	      memset(line,0,256);
	    }

  	    fclose(filein);

	  }
	}

//********************************************************************************************************************************

void	main()
	{
	  Section=0;
	  length_count=0;

	  if ((!ReadActrendOFFfile()) && (!DoesDATfileExist()))
	  {
	    ProcessActrendEquFILE();
	    fp2=fopen("MACREND.DAT","wb");
	    ConvertDATfile();
	    fclose(fp2);
	  }
	  
	  printf("length of DAT file = %d\n",length_count);
	}

//********************************************************************************************************************************

char *strupr(char *str)
{
char *s = str;

	while(*s)
	  {
	  if(*s>='a' && *s<='z')
	    *s += ('A'-'a');
	  s++;
	  }
	return str;
}
