#include "Flc Vars.h"
#include "Flc Player.h"

#undef EXTERN
#define EXTERN extern
#include "Actua.Soccer.h"
#include "Blitter.h"
#include "FileUtils.h"
#include "Frontend.h"
#include "Mallocx.h"
#include "Palette.h"
#include "Play.h"

#define ReadData(X)	fread(TempBuffer, 1, X, FlcFp);

static void BuildNewPalette(BYTE *buffer)
{
short pa, cnt;
unsigned short color=0;

	memset( palette_buffer, 0, 768);
	pa = *buffer++; pa += *buffer++<<8;
	while(pa--)
	  {
	  color += (*buffer++)*3;
	  cnt = *buffer++; if(!cnt) cnt=256;
	  while(cnt--)
	    {
	    palette_buffer[color++] = buffer[0]>>2;
	    palette_buffer[color++] = buffer[1]>>2;
	    palette_buffer[color++] = buffer[2]>>2;
	    buffer+=3;
	    }
	  }
}

static void SwapData(unsigned char *addr, short size)
{
unsigned char B0;

	switch(size)
	  {
	  case 2:
		B0 = addr[0]; addr[0] = addr[1]; addr[1] = B0;
		break;
	  case 4:
	  	B0 = addr[0]; addr[0] = addr[3]; addr[3] = B0;	  		
	  	B0 = addr[1]; addr[1] = addr[2]; addr[2] = B0;
	  	break;
	  }	  		
}

void PlayGDV( )
{
short		iA;
short		iFrames;
long		LastTick = TickCount();
short		pa;
unsigned short	lines;
unsigned char	*p, *s, *s1;
signed char	c;
Boolean		flag = false;
FILE		*FlcFp;
BYTE		*TempBuffer;

short			oldRes = CurResFile();
short		movieResFile;
SndChannelPtr	gSoundChannel;
Handle		handleSound;

FLCHEADER	FlcHeader;
FLCCHUNKH	FlcChunkH;
FLCCHUNK		FlcChunk;

#if DEBUGGING!=ON
	if( !OpenResourceFile( MOVIERESFILE, &movieResFile))
		{
		UseResFile( movieResFile);
		handleSound = GetResource( RESTYPE_MOVIEAUDIO, 1000); 
		if( handleSound)
			{
			HLock( handleSound); DetachResource( handleSound);
			}
		UseResFile( oldRes);
		CloseResFile( movieResFile);
		
		FlcFp = fopen( "Intro Movie","rb");
		BlitterMode = DOUBLE_320240;
	
		if(FlcFp)
			{
			TempBuffer = (unsigned char *)MallocX(100000);
			ClearScreen();
			fread( &FlcHeader, 1, 128, FlcFp);
			SwapData( (unsigned char *)&FlcHeader.width, 2);
			SwapData( (unsigned char *)&FlcHeader.height, 2);
			SwapData( (unsigned char *)&FlcHeader.frames, 2);
			memset( screenptr, 0, FlcHeader.height*FlcHeader.width);
	  
			SndPlay(  externalChannel[0], (SndListHandle)handleSound, true);

			iFrames=0;
			while(FlcHeader.frames--)
				{
				while(TickCount()-LastTick < 5)
					;
				LastTick=TickCount();

				if(Button() && FlcHeader.frames>FADE_SPEED)
					FlcHeader.frames = FADE_SPEED;
				if(FlcHeader.frames==FADE_SPEED)
					PaletteFlag  =PALETTE_FADE_DOWN;

				iFrames++;
				fread(&FlcChunkH, 1, 16, FlcFp);
				SwapData((unsigned char *)&FlcChunkH.chunks, 2);
				while(FlcChunkH.chunks--)
					{
					fread(&FlcChunk, 1, 6, FlcFp);
					SwapData((unsigned char *)&FlcChunk.size, 4);
					SwapData((unsigned char *)&FlcChunk.type, 2);

	      			flag = true;
	      			p = (BYTE *)TempBuffer;
	      			s = (BYTE *)screenptr;

					switch(FlcChunk.type)
						{
						case 4:	// Colour Map
								ReadData(FlcChunk.size-6);
								ClearScreen();
								BuildNewPalette((unsigned char *)TempBuffer);
								PaletteFlag = PALETTE_FADE_UP;
								break;
						case 7:	// Fli Delta
								ReadData(FlcChunk.size-6);
	        					lines  = *p++; lines += (*p++*256);
	      						while(lines)
									{
					        	  	pa = *p++; pa += (*p++*256);
									if(pa < 0)
										s += (-pa)*FlcHeader.width;
									else
						        		{
										lines--;
										s1=s;
										while(pa--)
											{
											s += *p++;
											c = *p++;
											if( c <0)
												{
												c=abs(c);
												while(c--)
													{
													*s++ = p[0];
													*s++ = p[1];
													}
												p+=2;
												}
											else
												{
												while(c--)
													{
													*s++ = *p++;
													*s++ = *p++;
													}
												}
											}
										s = s1 + FlcHeader.width;
										}
									}
								break;
							case 11:  // Compressed Colour Map
								ReadData(FlcChunk.size-6);
								break;
							case 12:  // Line Compressed
								ReadData(FlcChunk.size-6);
								lines  = *p++; lines += (*p++*256);
								s = (BYTE *)(screenptr + (lines*FlcHeader.width));
								lines  = *p++; lines += (*p++*256);
								while(lines--)
									{
					        		s1=s;
					        		pa = *p++;
					        		while(pa--)
					        			{
					        			s += *p++;
					        			c = *p++;
					        			if( c < 0)
					        				{
					        				c=abs(c);
					       					while(c--)
					       						*s++ = *p;
					       					p++;
					       					}
					       				else
					        				{
					        				while(c--)
					        					*s++ = *p++;
											}
										}
					       			s = s1 + FlcHeader.width;
									}
					        	break;
					      	case 13:  // Fade Screen To Black
					      		break;
					      	case 15:  // Block Run
					      		ReadData(FlcChunk.size-6);
					      		lines  = *p++; lines += (*p++*256);
					        	while(lines--)
					        		{
					        		s1=s;
					        		pa = *p++;
					        		while(pa--)
					        			{
					        			c = *p++;
					        			if( c < 0)
					        				{
					        				c = abs(c);
					        				while(c--)
					        					*s++ = *p;
					        				p++;
					        				}
					        			else
					        				{
					        				while(c--)
					        					*s++ = *p++;
					        				}
					        			}
					        		s = s1 + FlcHeader.width;
					        		}
					        	break;
					        case 16:  // Block Copy
								ReadData(FlcChunk.size-6);
					        	break;
	        				}
	        			}
				    if(flag && iFrames)
				      BlitBufferToScreen((double *)screenptr);
				    FadeThePalette();
					}
					
				PLAYER_StopSound( 0);
			  fclose(FlcFp);
			  }
		FreeX(TempBuffer);
		if( handleSound) DisposeHandle( handleSound);
		ClearScreen();
		}
#endif
}

#if 0
void PlayGDV(void)
{
short oldRes = CurResFile();
short		iA;
short		iFrames;
long		LastTick;
short		pa;
unsigned short	lines;
unsigned char	*p, *s, *s1;
BYTE	       *dataPtr;
signed char	c;
Boolean		flag = false;

#if DEBUGGING!=ON
	if( !OpenResourceFile( MOVIERESFILE, &movieResFile))
		{
		UseResFile( movieResFile);
		handleMovie = GetResource( RESTYPE_MOVIE, 1000);
		if( handleMovie)
			{
			HLock( handleMovie); DetachResource( handleMovie);
			}
		handleSound = GetResource( RESTYPE_MOVIEAUDIO, 1000); 
		if( handleSound)
			{
			HLock( handleSound); DetachResource( handleSound);
			}
		UseResFile( oldRes);
		CloseResFile( movieResFile);
		
		if( handleSound && handleMovie)
			{
			BlitterMode = DOUBLE_320240;
			ClearScreen();

			dataPtr = (BYTE *)*handleMovie;
			FlcHeader = (FLCHEADER *)dataPtr; dataPtr += 128;
			SwapData( (unsigned char *)&FlcHeader->width, 2);
			SwapData( (unsigned char *)&FlcHeader->height, 2);
			SwapData( (unsigned char *)&FlcHeader->frames, 2);
			memset( screenptr, 0, FlcHeader->height*FlcHeader->width);

			SndPlay(  externalChannel[0], (SndListHandle)handleSound, true);
			LastTick = TickCount();
			iFrames=0;
			while(FlcHeader->frames--)
				{
				if( Button() && FlcHeader->frames>FADE_SPEED)
					FlcHeader->frames = FADE_SPEED;
				if( FlcHeader->frames==FADE_SPEED)
					PaletteFlag = PALETTE_FADE_DOWN;
		      
				while(TickCount()-LastTick < 5)
			    	;
			    LastTick=TickCount();

				iFrames++;

				FlcChunkH = (FLCCHUNKH *)dataPtr; dataPtr += 16;
				SwapData( (unsigned char *)&FlcChunkH->chunks, 2);

				while(FlcChunkH->chunks--)
					{
			      	FlcChunk  = (FLCCHUNK *)dataPtr;
			      	SwapData((unsigned char *)&FlcChunk->size, 4);
					SwapData((unsigned char *)&FlcChunk->type, 2);
					flag = true;
					p = dataPtr+6;
					s = (BYTE *)screenptr;
					switch(FlcChunk->type)
						{
			        	case 4: // Colour Map
								dataPtr += ((FlcChunk->size+1)&0xfffffffe);
								ClearScreen();
								BuildNewPalette( p);
								PaletteFlag = PALETTE_FADE_UP;
								break;
						case 7: // Fli Delta 
								dataPtr += ((FlcChunk->size+1)&0xfffffffe);
								lines  = *p++; lines += (*p++*256);
					        	while(lines)
									{
									pa = *p++; pa += (*p++*256);
									if(pa < 0)
										s += (-pa)*FlcHeader->width;
					        	  	else
					        	    	{
					        	    	lines--;
					        	     	s1=s;
					        	     	while(pa--)
					       		       		{
					       					s += *p++;
					       					c = *p++;
											if( c <0)
					       			  			{
					       			  			c=abs(c);
					       			  			while(c--)
					       			    			{
					       			    			*s++ = p[0];
					       			    			*s++ = p[1];
					       			    			}
					       			  			p+=2;
					       			  			}
					       					else
					       			  			{
					       			  			while(c--)
					       			    			{
					       			    			*s++ = *p++;
					       			    			*s++ = *p++;
					       			    			}
												}
											}
										s = s1 + FlcHeader->width;
										}
									}
								break;
						case 11:  // Compressed Colour Map
								dataPtr += ((FlcChunk->size+1)&0xfffffffe);
								break;
						case 12:  // Line Compressed
								dataPtr += ((FlcChunk->size+1)&0xfffffffe);
								lines  = *p++; lines += (*p++*256);
								s = (BYTE *)(screenptr + (lines*FlcHeader->width));
								lines  = *p++; lines += (*p++*256);
								while(lines--)
									{
									s1=s;
									pa = *p++;
									while(pa--)
										{
										s += *p++;
										c = *p++;
										if( c < 0)
											{
											c=abs(c);
											while(c--)
												*s++ = *p;
											p++;
											}
										else
											{
											while(c--)
												*s++ = *p++;
											}
										}
									s = s1 + FlcHeader->width;
									}
								break;
						case 15:  // Block Run
								dataPtr += ((FlcChunk->size+1)&0xfffffffe);
								lines  = *p++; lines += (*p++*256);
								while(lines--)
									{
									s1=s;
									pa = *p++;
									while(pa--)
										{
										c = *p++;
										if( c < 0)
											{
											c = abs(c);
											while(c--)
												*s++ = *p;
											p++;
											}
										else
											{
											while(c--)
												*s++ = *p++;
											}
										}
									s = s1 + FlcHeader->width;
									}
								break;
						default:
								dataPtr +=6;
								break;
						}
				    if(flag && iFrames)
						BlitBufferToScreen((double *)screenptr);
				    FadeThePalette();
				    }
				}
			while( PaletteFlag)
				FadeThePalette();
			PLAYER_StopSound( 0);
			ClearScreen();
			PaletteFlag = 0;
			}
		if( handleMovie) DisposeHandle( handleMovie);
		if( handleSound) DisposeHandle( handleSound);
		}
#endif
}
#endif
