#include "Flc Vars.h"
#include "Flc Player.h"

#undef EXTERN
#define EXTERN extern
#include "Actua.Soccer.h"
#include "Blitter.h"
#include "Frontend.h"
#include "Mallocx.h"
#include "Palette.h"

#define ReadData(X)	fread(TempBuffer, 1, X, FlcFp);

static FLCHEADER	FlcHeader;
static FLCCHUNKH	FlcChunkH;
static FLCCHUNK		FlcChunk;

FILE		       *FlcFp;
unsigned char 	       *TempBuffer;

static void BuildNewPalette(BYTE *buffer)
{
short pa, cnt;
unsigned short color=0;

	memset( palette_buffer, 0, 768);
	pa = *buffer++; pa += *buffer++<<8;
	while(pa--)
	  {
	  color += (*buffer++)*3;
	  cnt = *buffer++; if(!cnt) cnt=256;
	  while(cnt--)
	    {
	    palette_buffer[color++] = buffer[0]>>2;
	    palette_buffer[color++] = buffer[1]>>2;
	    palette_buffer[color++] = buffer[2]>>2;
	    buffer+=3;
	    }
	  }
}

static void SwapData(unsigned char *addr, short size)
{
unsigned char B0;

	switch(size)
	  {
	  case 2:
		B0 = addr[0]; addr[0] = addr[1]; addr[1] = B0;
		break;
	  case 4:
	  	B0 = addr[0]; addr[0] = addr[3]; addr[3] = B0;	  		
	  	B0 = addr[1]; addr[1] = addr[2]; addr[2] = B0;
	  	break;
	  }	  		
}


void PlayGDV(void)
{
#if DEBUGGING==NO
	FlcPlay(":Movies:Intro English.flc");
//	FlcPlay(":Movies:Intro American.flc");
//	FlcPlay(":Movies:Intro Japan.flc");
//	FlcPlay(":Movies:Intro Germany.flc");
#endif
}

void FlcPlay(char *fileName)
{
short		iA;
short		iFrames;
long		LastTick = TickCount();
short		pa;
unsigned short	lines;
unsigned char	*p, *s, *s1;
signed char	c;
Boolean		flag = false;

	FlcFp = fopen(fileName,"rb");
	TempBuffer = (unsigned char *)MallocX(250000);
	BlitterMode = DOUBLE_320240;
	if(FlcFp)
	  {
	  ClearScreen();
	  fread( &FlcHeader, 1, 128, FlcFp);
	  SwapData( (unsigned char *)&FlcHeader.width, 2);
	  SwapData( (unsigned char *)&FlcHeader.height, 2);
	  SwapData( (unsigned char *)&FlcHeader.frames, 2);
	  memset( screenptr, 0, FlcHeader.height*FlcHeader.width);
	  
	  iFrames=0;
	  while(FlcHeader.frames--)
	    {
	    if(Button() && FlcHeader.frames>FADE_SPEED)
	      FlcHeader.frames = FADE_SPEED;
	    if(FlcHeader.frames==FADE_SPEED)
	      PaletteFlag  =PALETTE_FADE_DOWN;
	      

	    iFrames++;
	    fread(&FlcChunkH, 1, 16, FlcFp);
	    SwapData((unsigned char *)&FlcChunkH.chunks, 2);
	    while(FlcChunkH.chunks--)
	      {
	      fread(&FlcChunk, 1, 6, FlcFp);
	      SwapData((unsigned char *)&FlcChunk.size, 4);
	      SwapData((unsigned char *)&FlcChunk.type, 2);
	      switch(FlcChunk.type)
	        {
	        case 4:   // Colour Map
	        	ReadData(FlcChunk.size-6);
			ClearScreen();
	        	BuildNewPalette((unsigned char *)TempBuffer);
	        	PaletteFlag = PALETTE_FADE_UP;
	        	break;
	        case 7:   // Fli Delta 
	        	ReadData(FlcChunk.size-6); flag = true;
	        	p = (BYTE *)TempBuffer;
	        	s = (BYTE *)screenptr;
	        	lines  = *p++; lines += (*p++*256);
	        	while(lines)
        	  	  {
	        	  pa = *p++; pa += (*p++*256);
	        	  if(pa < 0)
	        	    s += (-pa)*FlcHeader.width;
	        	  else
	        	    {
	        	    lines--;
	        	     s1=s;
	        	     while(pa--)
	       		       {
	       			s += *p++;
	       			c = *p++;
				if( c <0)
	       			  {
	       			  c=abs(c);
	       			  while(c--)
	       			    {
	       			    *s++ = p[0];
	       			    *s++ = p[1];
	       			    }
	       			  p+=2;
	       			  }
	       			else
	       			  {
	       			  while(c--)
	       			    {
	       			    *s++ = *p++;
	       			    *s++ = *p++;
	       			    }
	       			  }
	       			}
	        	      s = s1 + FlcHeader.width;
	       		      }
	        	  }
	        	break;
	        case 11:  // Compressed Colour Map
	        	ReadData(FlcChunk.size-6);
	        	break;
	        case 12:  // Line Compressed
	        	ReadData(FlcChunk.size-6); flag = true;
	        	p = (BYTE *)TempBuffer;
	        	lines  = *p++; lines += (*p++*256);
	        	s = (BYTE *)(screenptr + (lines*FlcHeader.width));
	        	lines  = *p++; lines += (*p++*256);
	        	while(lines--)
	        		{
	        		s1=s;
	        		pa = *p++;
	        		while(pa--)
	        			{
	        			s += *p++;
	        			c = *p++;
	        			if( c < 0)
	        				{
	        				c=abs(c);
	       					while(c--)
	       						*s++ = *p;
	       					p++;
	       					}
	       				else
	        				{
	        				while(c--)
	        					*s++ = *p++;
						}
					}
	       			s = s1 + FlcHeader.width;
				}
	        	break;
	        case 13:  // Fade Screen To Black
	        	break;
		case 15:  // Block Run
	        	ReadData(FlcChunk.size-6); flag = true;
	        	p = (BYTE *)TempBuffer;
	        	s = (BYTE *)screenptr;
	        	lines  = *p++; lines += (*p++*256);
	        	while(lines--)
	        		{
	        		s1=s;
	        		pa = *p++;
	        		while(pa--)
	        			{
	        			c = *p++;
	        			if( c < 0)
	        				{
	        				c = abs(c);
	        				while(c--)
	        					*s++ = *p;
	        				p++;
	        				}
	        			else
	        				{
	        				while(c--)
	        					*s++ = *p++;
	        				}
	        			}
	        		s = s1 + FlcHeader.width;
	        		}
	        	break;
		case 16:  // Block Copy
			ReadData(FlcChunk.size-6); flag = true;
	        	break;
	        }
	      }
	    while(TickCount()-LastTick < 3)
	      ;
	    LastTick=TickCount();
	    if(flag && iFrames)
	      BlitBufferToScreen((double *)screenptr);
	    FadeThePalette();
	    }
	  fclose(FlcFp);
	  }
	FreeX(TempBuffer);
	ClearScreen();
}
